﻿# VERIFICATION

Verification is intended to assist the Chocolatey moderators and community
in verifying that this package's contents are trustworthy.

This package is published by __inventiv__ itself and contains `g.exe` tool.
It also contains several `.dll` libraries to serve `g.exe`. Among those
libraries, __Gazel__ and __Routine__ files are also developed and published
by __inventiv__, while the rest is 3rd party libraries.

## Verification instructions for 3rd party libraries

### Nuget Libraries

These libraries can be accessed through nuget. For each library in below
table;

1. Go to given url to download the `.nupkg` file
2. Unzip package contents to a folder
3. Browse to given path and locate `.dll` file
4. Use one of the following methods to obtain checksum;
   - Use powershell function 'Get-FileHash'
   - Use chocolatey utility 'checksum.exe'
5. Compare obtained checksum value to the provided value
   - ChecksumType is always `sha256`

|File|URL|Path|Checksum|
|-|-|-|-|
|Castle.Core.dll|[Castle.Core](https://www.nuget.org/packages/Castle.Core/4.4.0)|lib/net45|`9964A5C497DCAEA9BC047C719869A1C5483F9F383311A045D320148E0DF13A23`|
|Castle.Facilities.Logging.dll|[Castle.LoggingFacility](https://www.nuget.org/packages/Castle.LoggingFacility/5.0.1)|lib/net45|`489404721EF26F169D4D00E055D0ABF7B212ADE71A10391597162D1E42B39F3B`|
|Castle.Services.Logging.Log4netIntegration.dll|[Castle.Core-log4net](https://www.nuget.org/packages/Castle.Core-log4net/4.4.0)|lib/net45|`6D3FDA1178B44E156A8364FAAE649109C032BB9DD3572E1A5C170F3282B4BE69`|
|Castle.Windsor.dll|[Castle.Windsor](https://www.nuget.org/packages/Castle.Windsor/5.0.1)|lib/net45|`A0934C1690577A7E59C170CD82C1FB11B1D1879AE290A139D7661EA3302009A2`|
|CommandLine.dll|[CommandLineParser](https://www.nuget.org/packages/CommandLineParser/2.8.0)|lib/net461|`26AF31165DBF6AF3864609DF7834A06404E6CFBD8905BA202E0A0BB921326D57`|
|log4net.dll|[log4net](https://www.nuget.org/packages/log4net/2.0.8)|lib/net45-full|`AF5610C515D2244DB98C662636264C8177E89B1AFE407F88FD18A41D66F6E7E2`|
|Stubble.Core.dll|[Stubble.Core](https://www.nuget.org/packages/Stubble.Core/1.9.3)|lib/net45|`467AFBEC9D010D9CE66722D80AF436DBD141C98D164486932FDEEB304FF63BF6`|

### Extra .NET Libraries

These libraries are included because client might not have them even if
it has .NET framework installed. For each library in below table;

1. Use one of the following methods to obtain the checksum;
   - Use powershell function 'Get-FileHash'
   - Use chocolatey utility 'checksum.exe'
2. Compare obtained checksum value to the provided value
   - ChecksumType is always `sha256`

|File|Checksum|
|-|-|
|System.Collections.Immutable.dll|`2F05A2C489C2D30A6CCA346D4CE184323D70EB4F5AFA6BED34D5800274444E57`|
|System.Threading.Tasks.Extensions.dll|`18F733131E14E246D355EEB0F594A255CD07D5643B5A2975801669C52EB3850A`|
|System.Web.Http.dll|`FD09C793BDEB4AFFB991D04D2AE1B09DE0B81422D57968231884C66C8410DE02`|

## Verification instructions for developed binaries

These binaries are those developed by inventiv itself.

1. Go to url 'https://www.nuget.org/packages/Gazel.Cli' to download
   the `.nupkg` file.
2. Unzip package contents to a folder
3. For every binary in below table;
   1. Use one of the following methods to obtain the checksum for downloaded
      file;
      - Use powershell function 'Get-FileHash'
      - Use chocolatey utility 'checksum.exe'
   2. Obtain the checksum for the same file in the package
   3. Compare the two obtained checksum values
      - ChecksumType is always `sha256`

   |File|
   |-|
   |g.exe|
   |Gazel.Configuration.dll|
   |Gazel.dll|
   |Gazel.System.dll|
   |Routine.dll|
