﻿#region ApiClass
namespace /* &DefaultNamespace */
{
    using Routine.Client;
    using System;
    using System.Collections.Generic;

    public interface I/* &ApiClassName */
    {
        T Get<T>(string instanceId);
        object Get(Type type, string instanceId);

        T Get<T>();
        object Get(Type type);
    }

    public class /* &ApiClassName */ : I/* &ApiClassName */
    {
        private readonly Rapplication rapplication;

        public /* &ApiClassName */(Rapplication rapplication)
        {
            this.rapplication = rapplication;
        }

#region Get<T>(string instanceId)
        T I/* &ApiClassName */.Get<T>(string instanceId) => (T)((I/* &ApiClassName */)this).Get(typeof(T), instanceId);
        object I/* &ApiClassName */.Get(Type type, string instanceId)
        {
            /* #Loadables */
            if(type == typeof(/* #Service *//* >FullName *//* /Service */))
            {
                return /* #Service *//* >FullName *//* /Service */Impl.FromRobject(rapplication.Get(instanceId, "/* &Id */"));
            }
            /* /Loadables */

            throw new GetInstanceException(type);
        }
#endregion
    
#region Get<T>()
    T I/* &ApiClassName */.Get<T>() => (T)((I/* &ApiClassName */)this).Get(typeof(T));
        object I/* &ApiClassName */.Get(Type type)
        {
            /* #Singletons */
            if(type == typeof(/* #Service *//* >FullName *//* /Service */))
            {
                return /* #Service *//* >FullName *//* /Service */Impl.FromRobject(rapplication.Get("/* &Id */", "/* &ActualTypeId */", "/* &ViewTypeId */"));
            }
            /* /Singletons */

            throw new SingletonException(type);
        }
    }
#endregion

#region Helpers
    public class ObjectIdentifier : IEquatable<ObjectIdentifier>
    {
        public string Value { get; private set; }

        internal ObjectIdentifier(string value)
        {
            Value = value;
        }

        public override string ToString() => Value;

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != GetType()) return false;
            return Equals((ObjectIdentifier)obj);
        }

        public bool Equals(ObjectIdentifier other) => Equals(Value, other.Value);
        public override int GetHashCode() => (Value != null ? Value.GetHashCode() : 0);
    }

    public class GetInstanceException : Exception
    {
        public GetInstanceException(Type targetType) 
            : base($"Cannot get instance for {targetType}. Given type should be non view type and rendered as interface.") { }
    }

    public class SingletonException : Exception
    {
        public SingletonException(Type targetType)
            : base($"Given type {targetType} is not singleton") { }
    }
#endregion
}
#endregion

#region Services
/* #Services */
/* >Service */
/* /Services */
#endregion

#region Structs
/* #Structs */
/* >Struct */
/* /Structs */
#endregion

#region Enums
/* #Enums */
/* >Enum */
/* /Enums */
#endregion